from __future__ import print_function

import tensorflow as tf
from random import shuffle

max_input = 10000

### INPUT ###
def get_data():
	#f = codecs.open("datafile1.txt","r","unicode")
	f = open("datafile1.txt")
	data = f.readlines()
	f.close()
	#print(data)
	data = [d.split(",") for d in data]
		
	return data

def split(data):
	one = [d for d in data  if d[0] == 1]
	two = [d for d in data  if d[0] == 2]
	three = [d for d in data  if d[0] == 3]
	return one,two,three

def add_data(spl, num):
	sh = list(spl)
	multi = num // len(spl)
	for i in range(multi):
		shuffle(sh)
		spl.extend(sh)
	spl.extend(sh[:(num-multi*len(sh))])
	return spl
	
def preprocess_data(data):
	# normalizacia ?
	
	one,two,three = split(data)
	#print(len(one), len(two), len(three))
	maxi = max(len(one), len(two), len(three))
	one = add_data(one, maxi - len(one))
	two = add_data(two, maxi - len(two))
	three = add_data(three, maxi - len(three))
	#print(len(one), len(two), len(three))
	
	one.extend(two)
	one.extend(three)
	shuffle(one)
	#print(len(one))
	return one

def split_test_train(data):
	shuffle(data)
	p = int(len(data)/5)
	return data[:p], data[p:]

data = get_data()\
# zaporne su pokazene
data = [[max_input if int(c)<0 else int(c) for c in d] for d in data]
# viac nez max_input =10000 su pokazene 
data = [[max_input if c>max_input else c for c in d] for d in data]

#spodne 4 riadky su pokazene cele - moc blizko
#data = [d[:-16*4] for d in data]
data = preprocess_data(data)

test, train = split_test_train(data)

test_in = [d[1:] for d in test]
test_out = []
for d in test:
	if d[0] == 1:
		test_out.append([1,0,0])
	if d[0] == 2:
		test_out.append([0,1,0])
	if d[0] == 3:
		test_out.append([0,0,1])
		
train_in = [d[1:] for d in train]
train_out = []
for d in train:
	if d[0] == 1:
		train_out.append([1,0,0])
	if d[0] == 2:
		train_out.append([0,1,0])
	if d[0] == 3:
		train_out.append([0,0,1])
		
### INPUT ###


# Parameters
learning_rate = 0.001
training_epochs = 50
batch_size = 100
display_step = 1

# Network Parameters
n_hidden_1 = 5000 # 1st layer number of features
n_input = 192 # data input (img shape: 16*12 )
n_classes = 3 #  total classes (3 directions)
num_input_max = len(train_in)

# tf Graph input
x = tf.placeholder("float", [None, n_input], name="x")
y = tf.placeholder("float", [None, n_classes], name="y")

def next_batch(start, end):
	"""Return the next `batch_size` examples from this data set."""
	if end > num_input_max:
		"""
		# Finished epoch
		self._epochs_completed += 1
		# Shuffle the data
		perm = numpy.arange(self._num_examples)
		numpy.random.shuffle(perm)
		input = input[perm]
		output = output[perm]
		# Start next epoch
		start = 0
		index_in_epoch= batch_size
		assert batch_size <= self._num_examples
		"""
		return train_in[start:num_input_max], train_out[start:num_input_max]
	return train_in[start:end], train_out[start:end]


# Create model
def multilayer_perceptron(x, weights, biases):
	# Hidden layer with RELU activation
	layer_1 = tf.add(tf.matmul(x, weights['h1']), biases['b1'], name="layer_1")
	layer_1 = tf.nn.relu(layer_1)
	# Output layer with linear activation
	out_layer = tf.matmul(layer_1, weights['out']) + biases['out']
	return out_layer

# Store layers weight & bias
weights = {
	'h1': tf.Variable(tf.random_normal([n_input, n_hidden_1]), name="h1"),
	'out': tf.Variable(tf.random_normal([n_hidden_1, n_classes]), name="out")
}
biases = {
	'b1': tf.Variable(tf.random_normal([n_hidden_1]), name="b1"),
	'out': tf.Variable(tf.random_normal([n_classes]), name="bout")
}

# Construct model
pred = multilayer_perceptron(x, weights, biases)

# Define loss and optimizer
cost = tf.reduce_mean(tf.nn.softmax_cross_entropy_with_logits(logits=pred, labels=y))
optimizer = tf.train.AdamOptimizer(learning_rate=learning_rate).minimize(cost)

# Initializing the variables
init = tf.global_variables_initializer()

# Launch the graph
with tf.Session() as sess:
	sess.run(init)

	# Training cycle
	for epoch in range(training_epochs):
		avg_cost = 0.
		total_batch = int(len(train_in)/batch_size)
		index_in_epoch = 0
		# Loop over all batches
		for i in range(total_batch):
			start = index_in_epoch
			index_in_epoch += batch_size
			batch_x, batch_y = next_batch(start, index_in_epoch)
			# Run optimization op (backprop) and cost op (to get loss value)
			_, c = sess.run([optimizer, cost], feed_dict={x: batch_x, y: batch_y})
			# Compute average loss
			avg_cost += c / total_batch
			
		# Display logs per epoch step
		if epoch % display_step == 0:
			print("Epoch:", '%04d' % (epoch+1), "cost=", \
				"{:.9f}".format(avg_cost))
	print("Optimization Finished!")

	# Test model
	correct_prediction = tf.equal(tf.argmax(pred, 1), tf.argmax(y, 1))
	# Calculate accuracy
	accuracy = tf.reduce_mean(tf.cast(correct_prediction, "float"))
	print("Accuracy:", accuracy.eval({x: test_in, y: test_out}))


	#saver = tf.train.Saver()
	#saver.save(sess, './my-model')
	
	
	"""
	y = test_out
	feed_dict = {x: test_in}
	classification = tf.run(y, feed_dict)
	print(classification)
	"""
	
	#g1 = tf.train.export_meta_graph("file")
	
	### write to file ###
	trainedw_hidden = sess.run(weights.get('h1'))
	wh_temp = [' '.join(map(str, twh)) for twh in trainedw_hidden ]
	str_wh = '\n'.join(wh_temp)
	
	trainedb_hidden = sess.run(biases.get('b1'))
	str_bh =  ' '.join(map(str, trainedb_hidden))
	
	trainedw_out = sess.run(weights.get('out'))
	wout_temp = [' '.join(map(str, twout)) for twout in trainedw_out ]
	str_wout = '\n'.join(wout_temp)
	
	trainedb_out = sess.run(biases.get('out'))
	str_bout =  ' '.join(map(str, trainedb_out))
	
	network = open('network1.txt', 'w')
	network.write(str(n_hidden_1) + ' ' + str(n_input) + ' ' + str(n_classes) + '\n')
	# aktivacne funkcie - RELU a linear 
	
	network.write(str_wh+ '\n')
	network.write(str_bh+ '\n')
	network.write(str_wout+ '\n')
	network.write(str_bout)

	network.close()
